
# usage:
# ocamldep ... > .depend
# ./ocamldep2moduleList.sh .depend

#I know it could be 'optimized', for instance a few '*' or '^' or '$' could be removed.


##################
#remove the .cmi, .cmo and .cmx suffixes
s/\.cm[iox]//g


##################
#we would like to write the following:
# s/^\([^ ]\+\): \+\([^ ]\+\) \+\([^ ].*\)$/\1 \2\n\1: \3/g
#it looks for
#  foo: bar baz qux egg
#and replace it with
#  foo bar
#  foo: baz qux egg
#
#Then we would like to iterate this transformation.
#but our pattern would fail while reading the (freshly inserted)
#  foo bar
#
#Thus we add the beginning of the pattern (until '\?') to match and keep
#  foo bar
#
#The label ':begin' and the conditional branch 't label' iterates the transformation
#as long as it is possible.
:begin
s/^\([^:]*\n\)\?\([^ ]\+\): \+\([^ ]\+\) \+\([^ ].*\) *$/\1\2 \3\n\2: \4/g
t begin


##################
#Then we treat the case of
#  foo: bar
s/\([^ ]\+\): *\([^ ]\+\) *$/\1 \2/g


#note that there are only 5 lines of code!
